---
id: conclusion
title: "Project Conclusion"
sidebar_label: "Project Conclusion"
slug: /conclusion
---

During the graduation project the following question was central:


    How can I create the safest Azure infrastructure for the DTACT products 
    taking into consideration the current technologies used by the company, 
    the limitations of the company, and that are fully operational given the 
    timeframe of the internship?


----------------------



### Exploratory Research

To answer this question, **exploratory and library research** has been conducted into the inner workings
of the Azure environment, the configuration and deployment methods of Raven, and the opportunities that
come with the implementation of [IAC](../portofolio/iac) through **Terraform**. This technique uses code to create
infrastructure and provision the resources that are created through it.

### A new way to create infrastructure

The new technologies and methods of creating infrastructure through provisioning and deployment through **the use of code** were
tested by creating a **POC**. It has been found that there is indeed a great deal that can be automated and
managed through the use of [IAC](../portofolio/iac).

This is therefore the great added value that [IAC](../portofolio/iac) can have in the future of infrastructure **security**.
As more companies **opt to hold their infrastructure in the cloud** the need for better and more **secure management** will arise. In the years to come, the technologies used for IAC will become even more popular
and demanded of both Cloud Administrators, DevOps Engineers, and Security professionals.

### Adding security into the infrastructure process

The question **still remains on how to build the Azure infrastructure** in the fastest and **safest way**.
For example, the results of the POC showed that the process of building a solution **is a slow and
repetitive one**. In addition to this, the **security options** that must be enabled for each component
will **inevitably require more time and manpower** to develop. However, the **value** of having a **secure
environment** that can be easily managed and monitored overthrows the slow process of calibrating the
configurations for the desired results.

During this project, we worked on a **Terraform solution** that was creating the machines and services needed
to run Raven in the Azure environment **ensuring that all software**, **OS images**, and changes are **controlled and visible** to the company. Due to the challenges that appeared along the way, it still is too early to determine
if all the elements of Raven can be run within the Azure environment through an [IAC](../portofolio/iac) pipeline. Nonetheless,
the **added security** by controlling each step of the creation process and management advantages **are undeniably** an
the **great advantage** and the most efficient way to securely control the infrastructure of a company.

### Summary

Over the course of the entire project the following were achived:

* An Azure environment was created, explored, and managed for the company. Documentation 
and recommendations were made on how to securely manage and work with this environment and what
threats must be taken into consideration.

* Through the use of Packer, a secure Debian OS was provisioned with all the services needed for the 
deployment of Raven, in addition to this the image was fully integrated into the Gitlab pipelines to ensure
ease of management and monitoring of deployments.

* Furthermore, through the use of Terraform, the Azure infrastructure was developed while
controlling and securing the  variables, credentials, and service principles needed to 
maintain and create the resources needed for running a demo environment for Raven.

* Moreover, all of this was documented through code in the companies repositories establishing 
a good first step for the company to safely and correctly use an Azure environment that is 
is supervised with version control, automated with pipeline deployments, and can be easily expanded
and developed together with a team. 

* On top of all of this, security policies, methodologies and principles were researched and 
passed onto the team to ensure that the safe migration to an Azure environment is made in the future.



### Recommendations

Finally, an advisory report was written for DTACT, in which the findings of this research have been noted,
possible follow-up steps are described and recommendations are given. This advisory report was presented to DTACT
at the end of the internship.

[Advisory Report](../../static/documents/AdvisoryReportImproved.pdf)

### This is it

This is the end of my portfolio and the end of my school career. I look back on a fantastic
time in which I was allowed to do things that I never dared to dream I would do during an internship. I would
like to thank **the entire DTACT team** for welcoming and working together with me and teaching me new things every day,
but more especially I would like to thank my graduation mentor **Brandon van Houten** for all the help and guidance he has given me,
and last but not least my teacher, **Martin Ederveen** for the support and advice during the project.

All code, documentation, and research mentioned, displayed or presented in this portfolio has been written by
Gabriel Vlad Luca for DTACT. This data may not be reused, showcased, or traded in any way without the permission
of Gabriel Vlad Luca.

This project was finished in the middle of 2021 during the end of the Corona lockdown. If any piece of the research
is missing at some point in the future, pleace contact Gabriel Vlad Luca via GitHub, Linkedin or in person. Thanks!

-----------------------------
### [Advisory Report](../../static/documents/AdvisoryReportImproved.pdf)

-----------------------------